searchData={"items":[{"type":"behaviour","title":"AI","doc":"AI is a behavior module that defines the interface for interacting with\nOpenAI's API. It provides a common interface for the various OpenAI-powered\noperations used by the application.","ref":"AI.html"},{"type":"function","title":"AI.get_completion/2","doc":"","ref":"AI.html#get_completion/2"},{"type":"function","title":"AI.get_embeddings/2","doc":"See `AI.EmbeddingsAgent.get_embeddings/2`.","ref":"AI.html#get_embeddings/2"},{"type":"callback","title":"AI.get_embeddings/2","doc":"","ref":"AI.html#c:get_embeddings/2"},{"type":"function","title":"AI.get_outline/3","doc":"See `AI.Agent.CodeMapperAgent`.","ref":"AI.html#get_outline/3"},{"type":"callback","title":"AI.get_outline/3","doc":"","ref":"AI.html#c:get_outline/3"},{"type":"function","title":"AI.get_summary/3","doc":"See `AI.FileSummaryAgent.get_summary/3`.","ref":"AI.html#get_summary/3"},{"type":"callback","title":"AI.get_summary/3","doc":"","ref":"AI.html#c:get_summary/3"},{"type":"function","title":"AI.new/0","doc":"Create a new AI instance. Instances share the same client connection.","ref":"AI.html#new/0"},{"type":"callback","title":"AI.new/0","doc":"","ref":"AI.html#c:new/0"},{"type":"type","title":"AI.t/0","doc":"","ref":"AI.html#t:t/0"},{"type":"module","title":"AI.Agent.Answers","doc":"This module provides an agent that answers questions by searching a database\nof information about the user's project. It uses a search tool to find\nmatching files and their contents in order to generate a complete and concise\nanswer for the user.","ref":"AI.Agent.Answers.html"},{"type":"function","title":"AI.Agent.Answers.handle_tool_call/2","doc":"","ref":"AI.Agent.Answers.html#handle_tool_call/2"},{"type":"function","title":"AI.Agent.Answers.new/2","doc":"","ref":"AI.Agent.Answers.html#new/2"},{"type":"function","title":"AI.Agent.Answers.perform/1","doc":"","ref":"AI.Agent.Answers.html#perform/1"},{"type":"type","title":"AI.Agent.Answers.t/0","doc":"","ref":"AI.Agent.Answers.html#t:t/0"},{"type":"module","title":"AI.Agent.CodeMapper","doc":"","ref":"AI.Agent.CodeMapper.html"},{"type":"function","title":"AI.Agent.CodeMapper.get_outline/1","doc":"","ref":"AI.Agent.CodeMapper.html#get_outline/1"},{"type":"function","title":"AI.Agent.CodeMapper.new/3","doc":"","ref":"AI.Agent.CodeMapper.html#new/3"},{"type":"module","title":"AI.Agent.Defrag","doc":"","ref":"AI.Agent.Defrag.html"},{"type":"function","title":"AI.Agent.Defrag.msgs_to_defrag/1","doc":"","ref":"AI.Agent.Defrag.html#msgs_to_defrag/1"},{"type":"function","title":"AI.Agent.Defrag.summarize_findings/1","doc":"","ref":"AI.Agent.Defrag.html#summarize_findings/1"},{"type":"module","title":"AI.Agent.Embeddings","doc":"This module provides an agent that generates embeddings for text data.","ref":"AI.Agent.Embeddings.html"},{"type":"function","title":"AI.Agent.Embeddings.get_embeddings/2","doc":"Get embeddings for the given text. The text is split into chunks of 8192\ntokens to avoid exceeding the model's input limit. Returns a list of\nembeddings for each chunk.","ref":"AI.Agent.Embeddings.html#get_embeddings/2"},{"type":"module","title":"AI.Agent.FileInfo","doc":"","ref":"AI.Agent.FileInfo.html"},{"type":"function","title":"AI.Agent.FileInfo.get_summary/1","doc":"","ref":"AI.Agent.FileInfo.html#get_summary/1"},{"type":"function","title":"AI.Agent.FileInfo.new/3","doc":"","ref":"AI.Agent.FileInfo.html#new/3"},{"type":"module","title":"AI.Agent.FileSummary","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","ref":"AI.Agent.FileSummary.html"},{"type":"function","title":"AI.Agent.FileSummary.get_summary/3","doc":"","ref":"AI.Agent.FileSummary.html#get_summary/3"},{"type":"module","title":"AI.Agent.Spelunker","doc":"","ref":"AI.Agent.Spelunker.html"},{"type":"function","title":"AI.Agent.Spelunker.handle_tool_call/2","doc":"","ref":"AI.Agent.Spelunker.html#handle_tool_call/2"},{"type":"function","title":"AI.Agent.Spelunker.new/5","doc":"","ref":"AI.Agent.Spelunker.html#new/5"},{"type":"function","title":"AI.Agent.Spelunker.trace/1","doc":"","ref":"AI.Agent.Spelunker.html#trace/1"},{"type":"module","title":"AI.TokenSplitter","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","ref":"AI.TokenSplitter.html"},{"type":"function","title":"AI.TokenSplitter.new/3","doc":"","ref":"AI.TokenSplitter.html#new/3"},{"type":"function","title":"AI.TokenSplitter.next_chunk/2","doc":"","ref":"AI.TokenSplitter.html#next_chunk/2"},{"type":"behaviour","title":"AI.Tokenizer","doc":"","ref":"AI.Tokenizer.html"},{"type":"callback","title":"AI.Tokenizer.decode/1","doc":"","ref":"AI.Tokenizer.html#c:decode/1"},{"type":"callback","title":"AI.Tokenizer.encode/1","doc":"","ref":"AI.Tokenizer.html#c:encode/1"},{"type":"behaviour","title":"AI.Tools","doc":"","ref":"AI.Tools.html"},{"type":"callback","title":"AI.Tools.call/2","doc":"","ref":"AI.Tools.html#c:call/2"},{"type":"callback","title":"AI.Tools.spec/0","doc":"","ref":"AI.Tools.html#c:spec/0"},{"type":"type","title":"AI.Tools.agent/0","doc":"","ref":"AI.Tools.html#t:agent/0"},{"type":"module","title":"AI.Tools.FileInfo","doc":"","ref":"AI.Tools.FileInfo.html"},{"type":"module","title":"AI.Tools.GetOutline","doc":"","ref":"AI.Tools.GetOutline.html"},{"type":"module","title":"AI.Tools.ListFiles","doc":"","ref":"AI.Tools.ListFiles.html"},{"type":"module","title":"AI.Tools.Search","doc":"","ref":"AI.Tools.Search.html"},{"type":"module","title":"AI.Tools.SpelunkerTool","doc":"","ref":"AI.Tools.SpelunkerTool.html"},{"type":"module","title":"AI.Util","doc":"","ref":"AI.Util.html"},{"type":"function","title":"AI.Util.assistant_msg/1","doc":"Creates an assistant message object, representing the assistant's response.","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","title":"AI.Util.assistant_tool_msg/3","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","title":"AI.Util.model/1","doc":"","ref":"AI.Util.html#model/1"},{"type":"function","title":"AI.Util.split_text/2","doc":"","ref":"AI.Util.html#split_text/2"},{"type":"function","title":"AI.Util.system_msg/1","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","ref":"AI.Util.html#system_msg/1"},{"type":"function","title":"AI.Util.tool_msg/3","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#tool_msg/3"},{"type":"function","title":"AI.Util.truncate_text/2","doc":"","ref":"AI.Util.html#truncate_text/2"},{"type":"function","title":"AI.Util.user_msg/1","doc":"Creates a user message object, representing the user's input prompt.","ref":"AI.Util.html#user_msg/1"},{"type":"type","title":"AI.Util.model/0","doc":"","ref":"AI.Util.html#t:model/0"},{"type":"type","title":"AI.Util.msg/0","doc":"","ref":"AI.Util.html#t:msg/0"},{"type":"module","title":"Cmd.Ask","doc":"","ref":"Cmd.Ask.html"},{"type":"function","title":"Cmd.Ask.run/1","doc":"","ref":"Cmd.Ask.html#run/1"},{"type":"module","title":"Cmd.Files","doc":"","ref":"Cmd.Files.html"},{"type":"function","title":"Cmd.Files.run/1","doc":"","ref":"Cmd.Files.html#run/1"},{"type":"module","title":"Cmd.Indexer","doc":"This module provides the functionality for the `index` sub-command.","ref":"Cmd.Indexer.html"},{"type":"function","title":"Cmd.Indexer.new/2","doc":"Create a new `Indexer` struct.","ref":"Cmd.Indexer.html#new/2"},{"type":"function","title":"Cmd.Indexer.run/1","doc":"Run the indexing process using the given `Indexer` struct. If `force_reindex`\nis `true`, the project will be deleted and reindexed from scratch.","ref":"Cmd.Indexer.html#run/1"},{"type":"module","title":"Cmd.Projects","doc":"","ref":"Cmd.Projects.html"},{"type":"function","title":"Cmd.Projects.run/1","doc":"","ref":"Cmd.Projects.html#run/1"},{"type":"module","title":"Cmd.Search","doc":"This module provides the functionality for the `search` sub-command.","ref":"Cmd.Search.html"},{"type":"function","title":"Cmd.Search.run/2","doc":"Searches the given project for previously indexed files (see `Indexing`) that\nmatch the given query. The search results are printed to the console.\n\nNote that the query input is first sent to OpenAI's API to generate an\nembedding to match against the vector store.","ref":"Cmd.Search.html#run/2"},{"type":"module","title":"Cmd.Summary","doc":"This module provides the functionality for the `summary` sub-command.","ref":"Cmd.Summary.html"},{"type":"function","title":"Cmd.Summary.run/1","doc":"Run the summary process using the given `project` and `file_path`.","ref":"Cmd.Summary.html#run/1"},{"type":"module","title":"Cmd.Torch","doc":"","ref":"Cmd.Torch.html"},{"type":"function","title":"Cmd.Torch.run/1","doc":"Permanently deletes the project from the store.","ref":"Cmd.Torch.html#run/1"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.main/1","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","ref":"Fnord.html#main/1"},{"type":"module","title":"Git","doc":"Module for interacting with git.","ref":"Git.html"},{"type":"function","title":"Git.is_ignored?/2","doc":"Check if a file is ignored by git.","ref":"Git.html#is_ignored?/2"},{"type":"module","title":"Queue","doc":"A module that implements a process pool using a GenServer.","ref":"Queue.html"},{"type":"function","title":"Queue.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Queue.html#child_spec/1"},{"type":"function","title":"Queue.init/1","doc":"","ref":"Queue.html#init/1"},{"type":"function","title":"Queue.join/1","doc":"Waits until the queue is empty and all workers have exited.","ref":"Queue.html#join/1"},{"type":"function","title":"Queue.map/2","doc":"Queues an Enum of jobs, executes them, and returns the results in order.","ref":"Queue.html#map/2"},{"type":"function","title":"Queue.queue/2","doc":"Adds a job to the queue and returns a Task.","ref":"Queue.html#queue/2"},{"type":"function","title":"Queue.shutdown/1","doc":"Shuts down the queue, preventing new jobs from being added.","ref":"Queue.html#shutdown/1"},{"type":"function","title":"Queue.start_link/2","doc":"Starts the Queue with the given callback function and maximum number of workers.\nReturns {:ok, pid}","ref":"Queue.html#start_link/2"},{"type":"module","title":"Scanner","doc":"The `Scanner` module traverses a directory recursively, skipping hidden files\nand files that should be ignored based on a `.gitignore` file. It also skips\nbinary files and files with a size of 0 bytes.","ref":"Scanner.html"},{"type":"function","title":"Scanner.count_files/1","doc":"Count the number of files in the directory, excluding hidden, ignored,\nbinary, and empty files.","ref":"Scanner.html#count_files/1"},{"type":"function","title":"Scanner.new/2","doc":"Create a new `Scanner` struct.","ref":"Scanner.html#new/2"},{"type":"function","title":"Scanner.reduce/4","doc":"Recursively scan the directory and accumulate a result using the provided\naccumulator and function.","ref":"Scanner.html#reduce/4"},{"type":"function","title":"Scanner.scan/2","doc":"Recursively scan the directory and call the callback function for each file.","ref":"Scanner.html#scan/2"},{"type":"module","title":"Search","doc":"","ref":"Search.html"},{"type":"function","title":"Search.cosine_similarity/2","doc":"","ref":"Search.html#cosine_similarity/2"},{"type":"function","title":"Search.get_results/1","doc":"","ref":"Search.html#get_results/1"},{"type":"function","title":"Search.new/2","doc":"Creates a new `Search` struct with the given options.","ref":"Search.html#new/2"},{"type":"module","title":"Settings","doc":"","ref":"Settings.html"},{"type":"function","title":"Settings.get/3","doc":"Get a value from the settings store.","ref":"Settings.html#get/3"},{"type":"function","title":"Settings.home/0","doc":"Get the path to the store root directory.","ref":"Settings.html#home/0"},{"type":"function","title":"Settings.new/0","doc":"","ref":"Settings.html#new/0"},{"type":"function","title":"Settings.set/3","doc":"Set a value in the settings store.","ref":"Settings.html#set/3"},{"type":"function","title":"Settings.settings_file/0","doc":"Get the path to the settings file.","ref":"Settings.html#settings_file/0"},{"type":"module","title":"Store","doc":"This module provides the functionality for storing and retrieving embeddings\nand metadata for files.","ref":"Store.html"},{"type":"function","title":"Store.delete_file/2","doc":"Permanently deletes the specified file from the store. Note that this is\n_only_ exposed for the sake of testing.","ref":"Store.html#delete_file/2"},{"type":"function","title":"Store.delete_missing_files/3","doc":"Permanently delete any files that are indexed but no longer exist on disk.","ref":"Store.html#delete_missing_files/3"},{"type":"function","title":"Store.delete_project/1","doc":"Permanently deletes the specified project's index directory and all its\ncontents.","ref":"Store.html#delete_project/1"},{"type":"function","title":"Store.get/2","doc":"Get the metadata, summary, and embeddings for the specified file. Returns\n`{:ok, info}` if the file exists, or `{:error, :not_found}` if it does not.\n\nThe structure of the returned `info` is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  summary: \"AI-generated summary of the file\",\n  embeddings: [\n    [0.1, 0.2, 0.3, ...],\n    [0.4, 0.5, 0.6, ...],\n    ...\n  ]\n}\n```","ref":"Store.html#get/2"},{"type":"function","title":"Store.get_embeddings/2","doc":"Get the embeddings for the specified file. Returns `{:ok, embeddings}` if the\nfile exists, or `{:error, :not_found}` if it does not. Note that if the input\nfile was greater than 8192 tokens, the embeddings will be split into multiple\nchunks.","ref":"Store.html#get_embeddings/2"},{"type":"function","title":"Store.get_entry_path/2","doc":"Get the path to the directory containing the metadata for the specified file.","ref":"Store.html#get_entry_path/2"},{"type":"function","title":"Store.get_hash/2","doc":"Get the hash for the specified file. Returns `{:ok, hash}` if the file\nexists, or `{:error, :not_found}` if it does not.","ref":"Store.html#get_hash/2"},{"type":"function","title":"Store.get_key/1","doc":"Get the key for the specified file, which is based on the file's full path\nand is used as the directory name for the file's metadata.","ref":"Store.html#get_key/1"},{"type":"function","title":"Store.get_outline/2","doc":"Get the symbol/ctags style outline for the specified file. Returns `{:ok,\noutline}` if the file exists, or `{:error, :not_found}` if it does not.","ref":"Store.html#get_outline/2"},{"type":"function","title":"Store.get_summary/2","doc":"Get the summary for the specified file. Returns `{:ok, summary}` if the file\nexists, or `{:error, :not_found}` if it does not.","ref":"Store.html#get_summary/2"},{"type":"function","title":"Store.has_embeddings?/2","doc":"Check if the specified file has embeddings. Returns `true` if any exist,\n`false` otherwise.","ref":"Store.html#has_embeddings?/2"},{"type":"function","title":"Store.has_outline?/2","doc":"Check if the specified file has an outline outline. Returns `true` if the file\nexists, or `false` if it does not.","ref":"Store.html#has_outline?/2"},{"type":"function","title":"Store.has_summary?/2","doc":"Check if the specified file has a summary file. Returns `true` if the file exists,\nor `false` if it does not.","ref":"Store.html#has_summary?/2"},{"type":"function","title":"Store.info/2","doc":"Get the metadata for the specified file. Returns `{:ok, data}` if the file\nexists, or `{:error, :not_found}` if it does not. The structure of the\nmetadata is as follows:\n\n```\n%{\n  file: \"path/to/file.ext\",\n  hash: \"DEADBEEF\",\n  timestamp: \"2021-01-01T00:00:00Z\",\n  fnord_path: \"path/to/store/FEEBDAED\"\n}\n```","ref":"Store.html#info/2"},{"type":"function","title":"Store.list_files/1","doc":"List all indexed files in the project. Returns a list of absolute, expanded,\nfile paths.","ref":"Store.html#list_files/1"},{"type":"function","title":"Store.list_projects/0","doc":"List all projects in the store. Returns a list of project names.","ref":"Store.html#list_projects/0"},{"type":"function","title":"Store.new/1","doc":"Create a new `Store` struct.","ref":"Store.html#new/1"},{"type":"function","title":"Store.put/6","doc":"Store the metadata, summary, and embeddings for the specified file. If the\nfile already exists in the store, it will be overwritten.","ref":"Store.html#put/6"},{"type":"module","title":"Tui","doc":"","ref":"Tui.html"},{"type":"function","title":"Tui.add_step/0","doc":"","ref":"Tui.html#add_step/0"},{"type":"function","title":"Tui.add_step/2","doc":"","ref":"Tui.html#add_step/2"},{"type":"function","title":"Tui.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Tui.html#child_spec/1"},{"type":"function","title":"Tui.finish_step/2","doc":"","ref":"Tui.html#finish_step/2"},{"type":"function","title":"Tui.finish_step/4","doc":"","ref":"Tui.html#finish_step/4"},{"type":"function","title":"Tui.init/1","doc":"","ref":"Tui.html#init/1"},{"type":"function","title":"Tui.start_link/1","doc":"","ref":"Tui.html#start_link/1"},{"type":"function","title":"Tui.stop/2","doc":"","ref":"Tui.html#stop/2"},{"type":"function","title":"Tui.update_step/3","doc":"","ref":"Tui.html#update_step/3"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\nFnord is a command line tool the builds a searchable database of your files,\nusing AI-generated embeddings to index and search your code base, notes, and\nother (non-binary) files. Notably, it provides a conversational interface to\nresearch within your project, answering complex questions about your code base.","ref":"readme.html"},{"type":"extras","title":"Installation - Fnord","doc":"1. Install `elixir` if necessary:\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n2. Add the mix escript path to your shell's PATH:\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n3. Install the script:\n```bash\nmix escript.install github sysread/fnord\n```\n\nUse the same command to reinstall. It will offer to overwrite the existing\ninstallation.\n\n4. Set `OPENAI_API_KEY`\n\nSet this in your shell environment to the OpenAI project key you wish to use\nfor this tool. You can create a new project and get a key\n[here](https://platform.openai.com/api-keys).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Fnord","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Index - Fnord","doc":"The first time you run this, especially on a large codebase, it will take a\nwhile to index everything. Subsequent runs will be faster, re-indexing only\nthose files which have changed since they were last indexed.\n\n```bash\nfnord index --project foo --dir /path/to/foo\n```\n\nYou can **reindex** the project, forcing it to reindex all files.\n\n```bash\nfnord index --project foo --dir /path/to/foo --reindex\n```\n\nYou can also watch the project for changes and reindex them as they happen\nusing [watchman](https://github.com/facebook/watchman). Just be sure to use\n`--quiet` to suppress interactive output.\n\n```bash\nwatchman-make -p '**/*' --settle 5 --run \"fnord index --project $project --dir $project_root --quiet\"\n```\n\n...or use the `fnord-watch` script in the [tools directory on\nGitHub](https://github.com/sysread/fnord/blob/main/tools/fnord-watch).\n\n```bash\nfnord-watch -p foo -d /path/to/foo\n```","ref":"readme.html#index"},{"type":"extras","title":"Search - Fnord","doc":"Search for files in the project that match a query.\n\n```bash\nfnord search --project foo --query \"some search query\"\n```\n\nIf you want more detail about each file matched:\n\n```bash\nfnord search --project foo --query \"some search query\" --detail\n```","ref":"readme.html#search"},{"type":"extras","title":"Ask - Fnord","doc":"Ask the AI assistant to answer questions about your project.\n\n```bash\nfnord ask foo \"how do you run the tests for this project?\"\n\n# Pipe output to `glow` to render markdown\nfnord ask foo \"summarize the dependencies of this project\" | glow\n```","ref":"readme.html#ask"},{"type":"extras","title":"Miscellaneous - Fnord","doc":"- **List projects:** `fnord projects`\n- **List files in a project:** `fnord files --project foo`\n- **Show the AI-generated summary of a file:** `fnord summary --project foo --file bar`\n- **Delete a project:** `fnord delete --project foo`\n\nNote that deleting a project only deletes from the index, not the actual files.","ref":"readme.html#miscellaneous"},{"type":"extras","title":"Tool usage - Fnord","doc":"Internally, the `ask` command uses the OpenAI chat completions API to generate\na response, implementing a function tool to allow the assistant to query the\ndatabase for information.\n\n`fnord` can be used to implement a similar tool for your own projects. While\nthe `ask` command severely limits the parameters that the assistant may utilize\n(`query` only, with `project` being provided by the user's invocation of the\ncommand), the following syntax includes the full set of parameters available\nfor the `search` command.\n\n```json\n{\n  \"name\": \"search_tool\",\n  \"description\": \"Searches for matching files and their contents in a project.\",\n  \"parameters\": {\n    \"type\": \"object\",\n    \"properties\": {\n      \"project\": {\n        \"type\": \"string\",\n        \"description\": \"Project name for the search.\"\n      },\n      \"query\": {\n        \"type\": \"string\",\n        \"description\": \"The search query string.\"\n      },\n      \"detail\": {\n        \"type\": \"boolean\",\n        \"description\": \"Include AI-generated file summary if set to true.\"\n      },\n      \"limit\": {\n        \"type\": \"integer\",\n        \"description\": \"Limit the number of results (default: 10).\"\n      },\n      \"concurrency\": {\n        \"type\": \"integer\",\n        \"description\": \"Number of concurrent threads to use for the search (default: 4).\"\n      }\n    },\n    \"required\": [\"project\", \"query\"]\n  }\n}\n```\n\n# TODO\n- output formatted markdown results from `ask`\n- mitigate owl's bs; this thing is chincy af\n- we have GOT to come up with something bettern than `Owl`; it has SO many visual glitches, especially when there are many steps\n- restore progress display in indexer subcommand\n- nested tasks in tui\n- abstract agents out into a behaviour\n  - support for tool calls\n  - support for \"accumulator\" agents","ref":"readme.html#tool-usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}